# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://find-sec-bugs.github.io/bugs.htm
# yamllint enable
---
rules:
  - id: "kotlin_crypto_rule-CipherPaddingOracle"
    languages:
      - "kotlin"
    message: |
      This specific mode of CBC with PKCS5Padding is susceptible to padding oracle attacks. An
      adversary could potentially decrypt the message if the system exposed the difference between
      plaintext with invalid padding or valid padding. The distinction between valid and invalid
      padding is usually revealed through distinct error messages being returned for each condition.
    severity: "ERROR"
    metadata:
      shortDescription: "Use of a broken or risky cryptographic algorithm"
      category: "security"
      cwe: "CWE-327"
      owasp:
        - "A3:2017-Sensitive Data Exposure"
        - "A02:2021-Cryptographic Failures"
      technology:
        - "java"
      security-severity: "CRITICAL"

    patterns:
      - pattern: |-
          javax.crypto.Cipher.getInstance($TRANSFORMATION)
      - metavariable-regex:
          metavariable: "$TRANSFORMATION"
          regex: '^"[^/]*/CBC/PKCS5Padding'
      - metavariable-pattern:
          metavariable: "$TRANSFORMATION"
          patterns:
            - pattern-not-regex: '^"(RSA|ECIES)/'
